//+------------------------------------------------------------------+
//|                                                     overtest.mq5 |
//+------------------------------------------------------------------+
class CLogicNode {
	public:
	virtual bool process() {
		return (false);
	}
};

class CAndLogicNode: public CLogicNode {
	public:
	CLogicNode* a;
	CLogicNode* b;
	bool process() {
		bool result = false;
		if (CheckPointer(a) && CheckPointer(b)) {
			result = operate(a,b);
		}
		return (result);
	}
	
	bool operate(CLogicNode* s1, CLogicNode* s2) {
		//   
		/*
		bool S1 = s1.process(); //  and1  S1=false
		bool S2 = s2.process(); //  and1    and2  operate  S1   true   false
		return (S1 && S2); //   and1 return(true && true);
		*/
		return (s2.process() && s1.process()); // 
	}
};

class CStateNode:public CLogicNode {
	public:
	bool state;
	
	void CStateNode() {
		state = false;
	}
	
	bool process() {
		return (state);
	}
};


int OnInit() {
	CAndLogicNode* and1 = new CAndLogicNode();
	CAndLogicNode* and2 = new CAndLogicNode();
	
	CStateNode* state1 = new CStateNode();
	CStateNode* state2 = new CStateNode();
	CStateNode* state3 = new CStateNode();

	state1.state = false;
	state2.state = true;
	state3.state = true;
	
	// 1- AND
	and1.a = state1; //  state=false
	and1.b = and2; //   true AND true
	
	and2.a = state2; //  state=true
	and2.b = state3; //  state=true
	 
	Print (and1.process()); //   false. ,      operate,  true;
	delete(state1); delete(state2); delete(state3); delete(and1); delete(and2);
	return (0);
}

//    OnInit:
/*
          (false)---\
(true)---\          [AND1]---- ?
          [AND2] ---/
(true)---/

*/

void OnDeinit(const int reason){
}

void OnTick(){
}

